#!/bin/bash
#
#   Hitachi Fibre Channel Adapter Driver Installer for RHEL7
#
#   $Header: /home/cvs_linux/tools/install/Attic/hfcinst.el7.sh,v 1.1.2.2 2014/07/03 23:52:06 yyamada Exp $
#   $Log: hfcinst.el7.sh,v $
#   Revision 1.1.2.2  2014/07/03 23:52:06  yyamada
#   Updated kernel version string from 3.10.0-121 to 3.10.0-123
#
#   Revision 1.1.2.1  2014/06/30 11:19:19  yyamada
#   RHEL7 Support
#
#   Revision 1.1.2.8  2012/10/22 14:08:21  toyo
#   Modifies hfcinst.el6.sh to resolve uninstall bug.
#
#   Revision 1.1.2.7  2012/06/19 19:45:53  toyo
#   Resolves the install problem of the raslog linkage module.
#
#   Revision 1.1.2.6  2011/11/16 17:57:44  toyo
#    Modifies hfcinst.el6.sh for RHEL6.2
#
#   Revision 1.1.2.5  2011/08/14 10:59:16  toyo
#   Commits new hfcinst.el6.sh for RHEL6.1
#
#   Revision 1.1.2.7.2.1.12.1.4.1  2010/09/07 23:31:17  eteshima
#
if [ "$1" != "install" -a "$1" != "uninstall" ]; then
        echo "Usage : hfcinst.el7.sh install/uninstall [kvariant]"
        echo "example(install  ) : hfcinst.el7.sh install"
        echo "       (uninstall) : hfcinst.el7.sh uninstall"
        exit 1
fi
DRVDIR="drivers"
DRVMODU="hfcldd"
CNFMODU="hfcldd_conf"
MPMODU="hfcldd_mp"
RLOGLINK="hraslog_link.ko"
RASLOG="hraslog.ko"
HOSTTYPE=$(uname -m)
TOOLSDIR="/opt/hitachi/drivers/hba"
INSTLOG="/tmp/hfcldd_install.log"
if [ "$HOSTTYPE" = "i686" ]; then
	KERNVER="2.6.32-71.el6.i686"
	KERNVER1="2.6.32-131.0.15.el6.i686"
	KERNVER2=`uname -r`
else
	KERNVER="3.10.0-30.el7.x86_64"
	KERNVER1="3.10.0-123.el7.x86_64"
	KERNVER2=`uname -r`
fi
if [ "$HOSTTYPE" = "ia64" ]; then
	BOOTDIR="boot/efi/efi/redhat"
else
	BOOTDIR="boot"
fi
echo "      Boot directory      : $BOOTDIR" > $INSTLOG

MODCONF="hfcldd_param.conf"
#if [ ! -f "/etc/modprobe.d/$MODCONF" ]; then
#	echo " ---- No configuration file was found (/etc/$MODCONF)"  >> $INSTLOG
#	exit 1
#fi
DRVNAME="hfcldd.ko"
CNFNAME="hfcldd_conf.ko"
echo "      Configulation file  : $MODCONF"    >> $INSTLOG
echo "      Kernel version      : $KERNVER2"    >> $INSTLOG
echo "      Host Type           : `uname -m`"  >> $INSTLOG
if [ "$1" = "install" ]; then
	echo " ---- Install  @Hitachi Fibre Channel Adapter Driver - `date`" >> $INSTLOG
#	find /lib/modules/$KERNVER/updates -name $RLOGLINK -exec mv {} {}.hraslog.rename \;
	if [ ! -f "/lib/modules/$KERNVER1/extra/hraslog/hraslog.ko" ]; then
		echo "        hraslog.ko is not installed"   >> $INSTLOG
	else
		echo "        hraslog.ko is already installed"   >> $INSTLOG
		echo "        - rename hraslog_link.ko"   >> $INSTLOG
		cp  /lib/modules/$KERNVER1/extra/hfcldd/$RLOGLINK /lib/modules/$KERNVER1/extra/hfcldd/$RLOGLINK.hraslog.rename 2>> /dev/null
	fi
#	find /lib/modules/$KERNVER/updates -name $DRVNAME -exec mv {} {}.backup \;
#	find /lib/modules/$KERNVER/updates -name $CNFNAME -exec mv {} {}.backup \;
#	find /lib/modules/$KERNVER/kernel  -name $DRVNAME -exec mv {} {}.backup \;
#	find /lib/modules/$KERNVER/kernel  -name $CNFNAME -exec mv {} {}.backup \;
#	find /lib/modules/$KERNVER/extra/hfcldd  -name $DRVNAME -exec mv {} {}.backup \;
#	find /lib/modules/$KERNVER/extra/hfcldd  -name $CNFNAME -exec mv {} {}.backup \;
#	echo "      Modify /etc/modprobe.d/$MODCONF; old file is /etc/modprobe.d/$MODCONF.backup"   >> $INSTLOG
#	cp /etc/modprobe.d/$MODCONF /etc/modprobe.d/$MODCONF.backup
	rm -f /etc/modprobe.d/$MODCONF.backup

	echo " ---- Install Success "   >> $INSTLOG
else
	echo " ---- Uninstall  @Hitachi Fibre Channel Adapter Driver - `date`"   > $INSTLOG
	if [ -f "/lib/modules/$KERNVER1/extra/hraslog/hraslog.ko" ]; then
		rm -f /lib/modules/$KERNVER1/extra/hfcldd/$RLOGLINK.hraslog.rename 2>> /dev/null
	fi
	echo "      Modify /etc/modprobe.d/$MODCONF"   >> $INSTLOG
    echo " ---- Uninstall Success "   >> $INSTLOG
fi
